/*
 * gyak8.c
 *
 * Created: 2016.10.28. 10:24:21
 * Author : Hallgato
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include "lcd.h"
#include "timer.h"
#include "adc.h"

#define ledmask 0x03
#define FALSE 0
#define TRUE 1

#define BAL -1
#define KOZEP 0
#define JOBB 1

extern volatile uint8_t Task_1000ms,Task_100ms;
extern volatile uint16_t ADCresult;
extern volatile uint8_t ADC_Ready;

int ledA = FALSE;
int ledB = FALSE;
int kormany = KOZEP;
int szelso = FALSE;
int villogo = FALSE;

char s[16];
int main(void)
{
   TIMER0_Init();
   ADC_Init();
   lcdinit();
   
	DDRD &= ~(1<<PD0);   
	DDRD &= ~(1<<PD1); 
	DDRD &= ~(1<<PD2);

	PORTD |= (1<<PD0);
	PORTD |= (1<<PD1);
	PORTD |= (1<<PD2);

	EICRA = 0x0A;
	EIMSK |= (1<<INT0);
	EIMSK |= (1<<INT1);
	EIMSK |= (1<<INT2);

	DDRA = 0xFF;
	DDRB =0xFF;
	PORTA = 0x00;
	PORTB = 0x00;
	
	sei();
	
    while (1) 
    {
		
		if(Task_1000ms==TRUE)
		{
			if(ledB==TRUE){
			PORTB = PORTB ^=0x03;
			}
			if(ledA==TRUE){
			PORTA = PORTA ^=0x03;
			}
			
			
			Task_1000ms=FALSE;
		}
		if(Task_100ms==TRUE)
		{
	if(villogo==FALSE)
	{
		lcd_set_address(0);
		sprintf(s,"Kormny: %d  ",ADCresult);
		lcdreir(s);
		

			if(ADCresult<300)
			{
				kormany=BAL;
				lcd_set_address(40);
				lcdreir("Bal   ");
			}
			if (ADCresult>=300)
			{
				kormany=KOZEP;
				lcd_set_address(40);
				lcdreir("Kozep   ");
				if(ADCresult>=700)
				{
				kormany=JOBB;
					lcd_set_address(40);
						lcdreir("Jobb   ");
				}
			}
			if(kormany!=0)
			{
				szelso =TRUE;
			}
			if(szelso==TRUE & kormany==KOZEP)
				{
					ledA=FALSE;
					PORTA=0x00;
					ledB=FALSE;
					PORTB=0x00;
					szelso=FALSE;
				}
		}
		else
			{
						lcd_set_address(40);
						lcdreir("Veszvillogo");
			}
		}
    }
}

ISR(INT0_vect)
{
	if(ledB==FALSE)
	{
	ledB=TRUE;
	ledA=FALSE;
	PORTA = 0x00;
	}
	else
	{
		ledB=FALSE;
		PORTB=0x00;
	}
}
ISR(INT1_vect)
{
		if(ledA==FALSE)
		{
		ledB=FALSE;
		ledA=TRUE;
		PORTB=0x00;
	}
	else
	{
		ledA=FALSE;
		PORTA=0x00;
	}
}
ISR(INT2_vect)
{
	if(villogo==FALSE)
	{
		villogo=TRUE;
		PORTA=0x00;
		PORTB=0x00;
		ledB=TRUE;
		ledA=TRUE;
	}
	else
	{
		villogo=FALSE;
		ledB=FALSE;
		ledA=FALSE;
	}
		
}